package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLBasicSetList_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLBasicSetList extends JNIObject  {
	
	/* @generated */
	protected ISLBasicSetList(long ptr) {
		/*** PROTECTED REGION ID(ISLBasicSetList_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLBasicSetList build(long ptr) {
		return new ISLBasicSetList(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLBasicSetList_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_basic_set_list_alloc 
	 * 
	 * @generated
	**/
	 public static ISLBasicSetList build(ISLContext ctx, int n) { 
		/*** PROTECTED REGION ID(static_isl_basic_set_list_alloc) DISABLED START ***/
		ISLBasicSetList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicSetList.build(ISLNative.isl_basic_set_list_alloc(getNativePtr(ctx), n));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLBasicSetList bsetlist, int format) { 
		/*** PROTECTED REGION ID(static_isl_basic_set_list_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_list_to_string(getNativePtr(bsetlist), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_basic_set_list_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_basic_set_list_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_basic_set_list_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_copy 
	 * 
	 * @generated
	**/
	public ISLBasicSetList copy() {
		/*** PROTECTED REGION ID(isl_basic_set_list_copy) DISABLED START ***/
		ISLBasicSetList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicSetList.build(ISLNative.isl_basic_set_list_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_basic_set_list_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_basic_set_list_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_n_basic_set 
	 * 
	 * @generated
	**/
	public int getNbBasicSets() {
		/*** PROTECTED REGION ID(isl_basic_set_list_n_basic_set) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_list_n_basic_set(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_get_basic_set 
	 * 
	 * @generated
	**/
	public ISLBasicSet get(int index) {
		/*** PROTECTED REGION ID(isl_basic_set_list_get_basic_set) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_list_get_basic_set(getNativePtr(this), index));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_set_basic_set 
	 * 
	 * @take this bset
	 * @generated
	**/
	public ISLBasicSetList set(int index, ISLBasicSet bset) {
		/*** PROTECTED REGION ID(isl_basic_set_list_set_basic_set) DISABLED START ***/
		ISLBasicSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, bset);
			try {
				res = ISLBasicSetList.build(ISLNative.isl_basic_set_list_set_basic_set(getNativePtr(this), index, getNativePtr(bset)));
			} finally {
				taken(this);
				taken(bset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_insert 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLBasicSetList insert(int pos, ISLBasicSet el) {
		/*** PROTECTED REGION ID(isl_basic_set_list_insert) DISABLED START ***/
		ISLBasicSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLBasicSetList.build(ISLNative.isl_basic_set_list_insert(getNativePtr(this), pos, getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_add 
	 * 
	 * @take this el
	 * @generated
	**/
	public ISLBasicSetList add(ISLBasicSet el) {
		/*** PROTECTED REGION ID(isl_basic_set_list_add) DISABLED START ***/
		ISLBasicSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, el);
			try {
				res = ISLBasicSetList.build(ISLNative.isl_basic_set_list_add(getNativePtr(this), getNativePtr(el)));
			} finally {
				taken(this);
				taken(el);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_drop 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSetList drop(int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_list_drop) DISABLED START ***/
		ISLBasicSetList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSetList.build(ISLNative.isl_basic_set_list_drop(getNativePtr(this), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_concat 
	 * 
	 * @take this list2
	 * @generated
	**/
	public ISLBasicSetList concat(ISLBasicSetList list2) {
		/*** PROTECTED REGION ID(isl_basic_set_list_concat) DISABLED START ***/
		ISLBasicSetList res;
		
		synchronized(LOCK) {
			checkParameters(this, list2);
			try {
				res = ISLBasicSetList.build(ISLNative.isl_basic_set_list_concat(getNativePtr(this), getNativePtr(list2)));
			} finally {
				taken(this);
				taken(list2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLBasicSetList_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
